C*******************************************************************
      real*8 function SVgg(s,t1,u1)
      implicit none

      integer  sclset         
      real*8 dilog,lntm, lnum, lntu,lndel,lnx
      real*8 s,t,u,m2,t1,u1,s1,x,sbar,beta,delta
      real*8 t12,u12
      real*8 zeta2
      real*8 ca, cf, co, ck, cqed, tf, nf    
      real*8 BQED,prefactor
      real*8 FOVSgg,FKVSgg,FQEDVSgg,FHLVSgg
      real*8 pi
      real*8 dump1, dump2
      real*8 mq,muR,kR,muF          
      parameter(pi = 3.141592653589793238d0)

      common/m2only/m2
      common/group/ca, cf, co, ck, cqed, tf, nf      
      common/plus/delta 
      common/sclchoice/mq, muR, kR, muF, sclset 

      zeta2 = pi*pi/6

      beta = dsqrt(1d0-4*m2/s)
      x = (1d0-beta)/(1d0+beta)
      lnx = dlog(x)
      sbar = s*beta
      s1 = 4d0*m2-s
      t=t1+m2
      u=u1+m2
      

      lndel = 0.d0
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lntu = dlog(t1/u1)

      t12 = t1*t1
      u12 = u1*u1

      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      dump2=(s/4d0/m2-1d0)/((s/4d0/m2-1d0)+10d0)

      prefactor = m2/s**2/4d0/(CA**2-1d0)**2/pi/16d0
      BQED = ((t12+u12)/(u1*t1)+4*m2*s/t1/u1*(1-m2*s/t1/u1))         

      FOVSgg= 0d0
      FKVSgg= 0d0
      FQEDVSgg = 0d0
      FHLVSgg = 0d0

      FOVSgg = 4*BQED*(
     .  2*(t12+u12)/s/s* lndel**2 +
     . (  (t12+u12)/s/s* (-1d0+dlog( (1d0+x)**2/x ))
     .    -4d0*t12/s/s*lntm ) * lndel   )

      FOVSgg = FOVSgg 
     . + 2d0- (4*(s+2*m2)/s + 2*(t-u)**2/s/s) * zeta2
     . - m2*(t-u)**4/s1/s/s/t/u 
     . + (t-u)**2*( 1d0/s/s1-3d0/16d0*s/s1/t/u+1d0/s/s
     .      -11d0/16d0/t/u+3d0/4d0*m2/s/t/u
     .      +m2*m2/s/s/t/u)
     . +s/s1-3d0/16d0*s*s*s/s1/t/u-63d0/16d0*s*s/t/u
     . +80d0/3d0*m2/s+19d0/4d0*s*m2/t/u + 8d0*m2*m2/t/u
     . -8*m2*m2*m2/s/t/u
     . -( 4*(s+2*m2)+24*s*m2*m2/s1/s1
     .   +(t-u)**2*(1.5d0*s/s1/s1+2.5d0/s1+3/s)
     .   -s*(s*s+2*s*m2-4*m2*m2+6*s*s*m2*m2/s1/s1)/t1/u1 )*zeta2/sbar
    
      FOVSgg = FOVSgg
     . +( s/2*(17*s-8*m2)/u+4*s*m2/t -3d0/32d0*s**4/s1/t/u)/t1
     . +( 3d0/64d0*s**4/t/u+3d0/16d0*s**3*m2/t/u-1d0/4d0*s**3/s1
     .    -s**2*(11d0/2d0-zeta2) - s*m2*(32d0/3d0-4d0*zeta2)
     .    -m2*m2*(16d0-16d0*zeta2) )/t1/u1
     . + 2*s**4/t1/t1/u1/u1+4*s**2*(s-m2)/t1/t1/u 
     . + 8*s**2*m2*m2*(1d0-zeta2)/t1/t1/u1/u1
     . +(-11d0-5d0*(t-u)/s-8*m2/s+2*(s**2-5*s*m2-3*m2**2)/s/t
     .   -2*m2**2*(s+m2)/s/t/t-8*(s+2*m2)/t1-32*m2*m2/t1/t1) *lntm
     . +(4*(s-2*m2)/s+5*s/s1+3*s*s/s1/s1
     .    +(t-u)**2*(3d0/s1/s1+4d0/s/s1-2d0/s/s)
     .    -s/4d0*(2*(s-4*m2)+3*s**3/s1/s1+5*s*s/s1)/t1/u1 )
     .    *dlog((1d0+x)**2/x)

      FOVSgg = FOVSgg
     . -(2d0+2d0*(t-u)**2/s/s-8d0*(t-u)/s-4d0*(s+4*m2)/t1
     . -2d0*(s*s+4d0*s*m2+8*m2*m2)/t1/u1
     . +8*(s*m2/t1/u1)**2)*lntm*lntu
      
      FOVSgg = FOVSgg
     . +( 4*u1*(s+4*m2)/s/t1-8*(t-u)/s )
     .   * ( dilog(1d0-t1/x/u1)-dilog(t/m2)-lntm*lnum-dlog(x)*lntm )
     . -( 8*(s+2*m2)+48*s*m2*m2/s1/s1
     .    +(t-u)**2*(3*s/s1/s1+5d0/s1+6d0/s)
     .    -2*s*(s**2+2*s*m2-4*m2*m2+6*s*s*m2*m2/s1/s1)/t1/u1)*
     .   (dilog(-x)+1d0/4d0*dlog(x)**2)/sbar
     . +2*(s+4*m2)*(2d0-s*s/t1/u1)/s*dlog(1d0+x)*dlog((1d0+x)/x)
     . +( 4*(s+3*m2)/s+(t-u)**2/s/s
     .      -0.5d0*(3*s**2+12*s*m2+16*m2*m2)/t1/u1
     .      +4*s*s*m2*m2/t1/t1/u1/u1 )*dlog(x)**2
     . +( 2*(3*s+8*m2)/s+2*(t-u)**2/s/s
     .      -2*(s*s+4*s*m2+8*m2*m2)/t1/u1+8*s**2*m2**2/t1/t1/u1/u1)
     .  *( dilog(1d0-t1*u1/s/m2)+2*dilog(1d0-t1/x/u1)
     .    -2*dlog(x)*lntm+(s-2*m2)/sbar*dlog(x) )
 
      FOVSgg = FOVSgg
     . +( 8*(s+2*m2)/s+4*(t-u)**2/s/s+4*(s+4*m2)/t1 +32*m2**2/t1/t1 )
     .   *(2*dlog(1d0+x)*lntm-dilog(1d0-t1/x/u1))


      FKVSgg = -4*BQED*(
     .  2* lndel**2 -
     . ( (3*t1**2+3*u1**2+4*t1*u1)/s/s+(s-2*m2)*(t12+u12)/s/s/sbar
     .  *dlog(x))*lndel )

      FKVSgg = FKVSgg
     .  -2d0+(9d0+8*m2/s)*zeta2-(t-u)**2*(1d0/s/s+m2*m2/s/s/t/u
     .     +5d0/4d0*m2/s/t/u-19d0/16d0/t/u)
     .  +1d0/4d0*(t-u)**4/s/s/t/u+128d0*m2**4/s/s/t/u
     .     -190d0*m2**3/s/t/u-1d0/4d0*s*m2/t/u-297d0/16d0*s*s/t/u
     .  +92d0*m2*m2/t/u-26d0*m2/s
     .  +( (19d0*s**2+8d0*s*m2-112d0*m2**2)/s+6d0*(t-u)**2/s
     .     -12*m2*(t-u)**2/s/s -(s-2*m2)*( 
     .     (5*s*s+20*s*m2+32*m2**2)/t1/u1 - 16*s*s*m2*m2/(t1*u1)**2))
     .     *zeta2/sbar
     .  -12*s*m2*(s-m2)/t1/t1/u -8*s**4*m2*m2*zeta2/(t1*u1)**3
     .  +2*s*s*m2*(s-m2*(12d0-26*zeta2))/(t1*u1)**2

      FKVSgg = FKVSgg
     .  +( (-3*s**3+6*s**2*m2+84*s*m2*m2-64*m2**3)/s
     .   -3*(s**2-2*s*m2+20*m2*m2)*zeta2+183d0/64d0*s**4/t/u
     .   +3d0/16d0*m2*t*u/s)/t1/u1
     .  +(1d0/16d0*(t+u)**3/s/s-13d0/32d0*(t**3+u**3)/s/s
     .   +3d0/32d0*(t**5+u**5)/s/s/t/u+1d0/4d0*m2*(t**2+u**2)/s/s
     .   -93d0/16d0*s*s/t+283d0/16d0*s*s/u-1d0/16d0*t**3/s/u
     .   -128*m2**4/s/s/u+264*m2**3/s/u-176*m2*m2/u+8*m2*s/u)/t1
     .  +(20d0+2*(t+7*m2)/s-(14*s*s-74*s*m2+2*m2*m2)/t/s
     .   + 2*m2*(8*s**2+7*s*m2+m2*m2)/s/t/t-16*m2*(s-6*m2)/t1/t1
     .   +32*(s-m2)/t1+8*m2*(2*s*s-s*m2-2*m2*m2)/t/t/u1
     .   +8*m2*(s*s-11*s*m2+8*m2*m2)/t/t1/u1) * lntm
     .  -( 311d0/20d0*s-64*m2*m2/s-18d0/5d0*t1**3/s/s
     .    +73d0/20d0*(t-u)**2/s-12*m2*(t-u)**2/s/s
     .   -(6*s**3+17*s**2*m2-40*s*m2*m2-32*m2**3)/t1/u1
     .    +24*(s*m2)**2*(s-2*m2)/t1/t1/u1/u1   )/sbar*lnx

      FKVSgg = FKVSgg
     .  +16*m2**2*(s**2/t1/u1-2d0)/t1/u1*lntm**2
     .  -( ( (19*s*s+8*s*m2-112*m2*m2)/2/s
     .   +(s-2*m2)*(3*(t-u)**2/s/s+8*(s*m2/t1/u1)**2
     .   -(5*s*s+20*s*m2+32*m2*m2)/t1/u1/2))/sbar
     .   -(3*s*s+18*s*m2+4*m2*m2)/t1/u1/2
     .   +(9*s+8*m2)/s/2 +8*(s*m2/t1/u1)**2 )*dlog(x)**2
     .  -( 2*( s*s-4*m2*s-16*m2*m2)/s-2*(t-u)-4*(s-2*m2)*
     .    (8*m2*m2/t1/t1+(s+4*m2)/t1))/sbar*dlog(x)*lntm
     .  -( 16d0-8*(s+2*m2)**2/t1/u1+48*s*s*m2*m2/(t1*u1)**2)
     .     *lntm*lnum
     .  -( 2*(7*s-8*m2)/s+2*(t-u)/s+16*s*m2*m2/t1**3-8*(m2/t1)**2
     .    +4*(s+2*m2)*(s-4*m2)/s/t1 -8*(s*s+s*m2-3*m2*m2)/t1/u1 )
     .    *dilog(t/m2)

      FKVSgg = FKVSgg
     . +8*(s-2*m2)*(3d0+8*m2/s+(t-u)**2/s/s
     .     -(s*s+4*s*m2+8*m2*m2)/t1/u1+4*(s*m2/t1/u1)**2 ) *
     .    (dlog(x)*dlog(1d0-x)+dilog(x))/sbar
     . +(14*s-96*m2*m2/s+2*(s-2*m2)*(2*(t-u)**2/s/s
     .     -s*(s+4*m2)/t1/u1))*(dlog(x)*dlog(1d0+x)+dilog(-x))/sbar


      FQEDVSgg = -4*BQED*( 1d0+(s-2*m2)/sbar*lnx ) *lndel 

      FQEDVSgg = FQEDVSgg
     . +2*zeta2+2d0+3*m2*(s-2*m2)/t/u-4*m2*(s-2*m2)*(5*s-8*m2)/s/s/t
     . -( 10*s-24*m2-s*(3*s*s+10*s*m2-24*m2*m2)/t1/u1
     . +16*(s-2*m2)*(s*m2/t1/u1)**2)*zeta2/sbar
     . +( 28*s*m2+32*m2**2-(3*s*s+8*m2*m2)*zeta2 )/t1/u1
     . -8*s*m2*(4*s*m2+8*m2*m2+s*m2*zeta2)/(t1*u1)**2
     . -4*(s*m2)**2*(s*s-8*s*m2-s*s*zeta2)/(t1*u1)**3
     . -8*m2*m2*(s-8*m2)/t1**3
     . +(2*s+52*m2-72*m2*m2/s+64*m2**3/s/s-(20*s*m2-100*m2**2
     .   +136*m2**3/s-64*m2**4/s/s)/u)/t1
     . -4*m2*(s-26*m2+16*m2*m2/s-s*(s-m2)/u)/t1/t1
     . +(4*s*(1d0-s*m2/t1/u1)+2*(s-2*m2)*(2-s*(s+4*m2)/t1/u1
     .  +4*(s*m2/t1/u1)**2))/sbar*dlog(x)
     . -(1d0-(3*s*s-8*m2**2)/t1/u1/2
     .  -(5*s-12*m2-s/t1/u1/2*(3*s*s+10*s*m2-24*m2*m2)
     .  +8*(s-2*m2)*(s*m2/t1/u1)**2)/sbar)* dlog(x)**2

      FQEDVSgg = FQEDVSgg
     . -2*(1d0-(27*s-32*m2)/t+(4*s*s-22*s*m2+15*m2*m2)/t/t
     .  +6*(5*s-4*m2)/t1-4*m2*(s-4*m2)/t1/t1
     .  +2*(13*s*s-18*s*m2+8*m2*m2)/t1/u1-2*(11*s*s-18*s*m2
     .  +8*m2*m2)/t/u1+2*(2*s**3-13*s*s*m2+18*s*m2*m2
     .  -8*m2**3)/t/t/u1)* lntm
     . -4*(s-(s+2*m2)*(s-4*m2)/t1-2*(s**3-12*s*m2*m2
     .   +8*m2**3)/t1/u1+8*m2*m2*(s-2*m2)/t1/t1)*dlog(x)*lntm/sbar
     . +4*(1d0-(s+4*m2)/t1-2*(m2/t1)**2+2*s*m2**2/t1**3
     .   -2*(s*s+s*m2-3*m2*m2)/t1/u1)* dilog(t/m2)
     . -8*(s-2*m2)*(2d0-s*(s+4*m2)/t1/u1+4*(s*m2/t1/u1)**2)
     .  *(dlog(x)*dlog(1d0-x)+dilog(x))/sbar
     . -2*(s-4*m2)*(2d0+s*(s+2*m2)/t1/u1)
     .  *(dlog(x)*dlog(1d0+x)+dilog(-x))/sbar


! take half of the function from Beenakker et al paper
! because of both calls with t1 <--> u1 later
 
      FHLVSgg = -m2*(t1-u1)**2/s/t1/u1/3d0*nf
      FHLVSgg =  FHLVSgg 
     .    -m2*(t1-u1)**2/s/t1/u1/3d0 
     .    -m2**2*(t1-u1)**2/s**2/t1/u1*(
     .    8d0-6d0*zeta2+4d0*beta*lnx+lnx**2)


! Contribution prop. to the delta func. in Eq.6.21 of PRD40 1 Beenakker et al 1989.
! It should be multiplied by -1/2 (correspondence with Li Lin Yang)
      FHLVSgg =  FHLVSgg*(-0.5)


      SVgg =  prefactor*(CA*CO*FOVSgg *dump2 
     ~  + CA*CK*FKVSgg                *dump1   
     ~  + CQED*FQEDVSgg               *dump1 
     ~  + CO*FHLVSgg                  *dump1 
     ~  )


      return
      end

C*******************************************************************
      real*8 function SVqq(s,t1,u1)
      implicit none


      integer  sclset         
      real*8 AQED, d2sig0, prefactor    
      real*8  dilog,lntm, lnum, lntu,lndel
      real*8 s,t,u,m2,t1,u1,s1,x,sbar,beta,delta
      real*8 ca, cf, co, ck, cqed, tf, nf    
      real*8 Fqq, Aqq,sfqq 
      real*8 t12,u12
      real*8 zeta2
      real*8 dump1, dump2
      real*8 mq,muR,kR,muF                      
      real*8 pi
      parameter(pi = 3.141592653589793238d0)

      common/m2only/m2
      common/group/ca, cf, co, ck, cqed, tf, nf       
      common/plus/delta                         
      common/sclchoice/mq, muR, kR, muF, sclset 


      zeta2 = pi*pi/6

      beta = dsqrt(1d0-4*m2/s)
      x = (1d0-beta)/(1d0+beta)
      sbar = s*beta
      s1 = 4d0*m2-s
      t=t1+m2
      u=u1+m2
      

      lndel = 0.d0     
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lntu = dlog(t1/u1)

      t12 = t1*t1
      u12 = u1*u1


      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      dump2=(s/4d0/m2-1d0)/((s/4d0/m2-1d0)+10d0)

      prefactor = m2/s**2/pi/16d0*CF/CA
      AQED = ((t12+u12)/s**2+2*m2/s)
      d2sig0 = m2/s**2*pi*CF/CA*AQED 
                            
      Fqq= 0d0
      Aqq= 0d0
      sfqq = 0d0


      Fqq = AQED*(
     .  8* lndel**2 +
     . ( -8*(dlog(t1*u1/s/m2)+1d0+(s-2*m2)/sbar*dlog(x) )
     .  - 32*dlog(t1/u1) )*lndel)



      Fqq = Fqq +AQED*(
     . 4*(s-2*m2)/sbar*(-3*dlog(x)-3d0/2d0*dlog(x)**2
     .   +4*dlog(x)*dlog(1d0-x)+2*dlog(x)*dlog(1d0+x)
     .   +4*dilog(x)+2*dilog(-x)+3*zeta2)
     . +2*s/sbar*dlog(x)+6*dlog(s/m2)
     .   -4*dlog(t1*u1/m2/m2)*dlog(s/m2)+2*dlog(t1*u1/m2/m2)**2
     .   +4*dilog(1d0-m2*s/t1/u1)-20d0+8*zeta2 )
     .   +8*m2/sbar*dlog(x) 


      Fqq = Fqq -AQED*(32d0*dlog(t1/u1)*lndel
     .  -16*dlog(t1/u1)*dlog(s/m2)-16*dlog(x)*dlog(t1/u1)
     .  -16*dilog(1d0-u1/x/t1)+16*dilog(1d0-t1/x/u1))
     .  - (-4*(t1-u1)/s*(dlog(s/m2)**2+2*zeta2)
     . +8*(t1-u1)/s1*dlog(s/m2)+(8*t1*u1-16*s*m2)/s/u*lnum
     . -(8*t1*u1-16*s*m2)/s/t*lntm+8*(t1-u1)/s/sbar/s1
     .  *(s*s-8*s*m2+8*m2*m2)*(zeta2+1d0/2d0*dlog(x)**2
     . +2*dilog(-x)) 
     . +(8d0+16*u/s)*(-lnum*dlog(s/m2)+lnum**2+dilog(u/m2))
     . -(8d0+16*t/s)*(-lntm*dlog(s/m2)+lntm**2+dilog(t/m2)))

      Aqq = AQED*(
     .  4*dlog(t1*u1/s/m2)+4*(s-2*m2)/sbar*dlog(x)
     .  +12*dlog(t1/u1)   ) *lndel 



      Aqq = Aqq +AQED*(
     . dlog(s/m2)**2+(-16d0/3d0+s*(s-16*m2)/s1/s1)*dlog(s/m2)
     . -4*lntm*lnum-2*(s-2*m2)/sbar*(-2*dlog(x)
     . -3d0/2d0*dlog(x)**2+4*dlog(x)*dlog(1d0-x)
     . +2*dlog(x)*dlog(1d0+x)+4*dilog(x)+2*dilog(-x)+3*zeta2)
     . -s/sbar*dlog(x)-dlog(x)**2-8*m2/s1
     . +2*s/s1/s1/sbar*(s*s-7*m2*s+24*m2*m2)
     .  *(zeta2+1d0/2d0*dlog(x)**2+2*dilog(-x))
     . -2*dilog(1d0-m2*s/t1/u1)+170d0/9d0-6*zeta2)

      Aqq = Aqq
     . -m2/s*dlog(s/m2)**2+s1**(-2)
     .  *(-s**2+12*s*m2+16*m2*m2)*dlog(s/m2)
     . +(2*s*m2-t1*u1)/s/t*lntm+(2*s*m2-t1*u1)/s/u*lnum
     . -(1d0+2*u/s)*(-lnum*dlog(s/m2)+lnum**2+dilog(u/m2))
     . -(1d0+2*t/s)*(-lntm*dlog(s/m2)+lntm**2+dilog(t/m2))
     . -4*m2/s1**2/sbar*(s*s-2*s*m2+16*m2*m2)
     .  *(zeta2+1d0/2d0*dlog(x)**2+2*dilog(-x))
     . -4*m2/sbar*dlog(x)-2*m2/s*zeta2+8*m2/s1


      Aqq = Aqq - AQED*( (-12d0*dlog(t1/u1))*lndel 
     . +6*dlog(t1/u1)*dlog(s/m2)+6*dlog(x)*dlog(t1/u1)
     . -6*dilog(1d0-t1/x/u1)+6*dilog(1d0-u1/x/t1))
     . - (+3d0/2d0*(t1-u1)/s*(dlog(s/m2)**2+2*zeta2)
     . -3*(t1-u1)/s1*dlog(s/m2)-(3*t1*u1-6*s*m2)/s/u*lnum
     . +(3*t1*u1-6*s*m2)/s/t*lntm
     . -3*(t1-u1)/s/sbar/s1
     .  *(s*s-8*s*m2+8*m2*m2)*(zeta2+1d0/2d0*dlog(x)**2+2*dilog(-x)) 
     . -(3d0+6*u/s)*(-lnum*dlog(s/m2)+lnum**2+dilog(u/m2))
     . +(3d0+6*t/s)*(-lntm*dlog(s/m2)+lntm**2+dilog(t/m2)))

C Now the term in eq. 2.15 in (Beenakker et al NPB351 p507)
C Light fermion loop contribution:

      sfqq = sfqq + 1d0/4d0/pi*nf/3d0/pi*
     .                 (-5d0/3d0+dlog(s/m2))*d2sig0

C Heavy fermion loop contribution:

      sfqq = sfqq + 1d0/4d0/pi*1d0/3d0/pi*(-5d0/3d0 -4*m2/s
     .   -dsqrt(1d0-4*m2/s)*(1d0+2*m2/s)*dlog(x) )*d2sig0

      SVqq = prefactor*( CF*Fqq + CA*Aqq ) + sfqq
      SVqq= SVqq*dump1

      return 
      end

C*******************************************************************

      real*8 function SxSgg(s,t1,u1)
      implicit none

      real*8 Lbeta, lntm, lnum, lnsm
      real*8 s,t,u,m2,t1,u1,x,beta
      real*8 zeta2,b2,Kodaira
      real*8 ca, cf, co, ck, cqed, tf, nf  
      real*8 BQED,prefactor,sigmaBorn
      real*8 FSxSgg
      real*8 pi
      real*8 dump1, dump2
      parameter(pi = 3.141592653589793238d0)
  
      common/m2only/m2
      common/group/ca, cf, co, ck, cqed, tf, nf

      zeta2 = pi*pi/6
      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0

      beta = dsqrt(1d0-4*m2/s)
      x = (1d0-beta)/(1d0+beta)
      Lbeta=(1d0-2*m2/s)/beta*dlog(x)
      
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)
      prefactor = m2/s**2/4d0/pi**3/16d0


      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      dump2=(s/4d0/m2-1d0)/((s/4d0/m2-1d0)+10d0)



      BQED = ((t1**2+u1**2)/(u1*t1)+4*m2*s/t1/u1*(1-m2*s/t1/u1))
      sigmaBorn = m2/s**2/2d0/(CA**2-1d0)**2/pi**3/16d0
     +     *BQED*(CO*(1-2*t1*u1/s**2)-CK)

      FSxSgg = 0d0

      FSxSgg = 
     +    sigmaBorn * (  - 16*zeta2*CA**2 + 2*Kodaira*CA )
      FSxSgg = FSxSgg + prefactor*BQED*(1-2*t1*u1/s**2)*
     + (CA**2-1d0)**(-1) * (  - 4*Lbeta*b2*CA**2 + 4*Lbeta*CA**3*
     +    lnsm - 8*Lbeta*CA**3*lnum + 2*Lbeta**2*CA**3 - 4*b2*
     +    CA**2*lnsm + 8*b2*CA**2*lnum + 8*b2*lntm - 8*b2*lnum 
     +     - 16*CA*lnsm*lntm + 16*CA*lnsm*lnum - 24*CA*lntm*lnum 
     +     + 28*CA*lntm**2
     +     - 4*CA*lnum**2 - 8*CA**3*lnsm*lnum + 2*CA**3*lnsm**2+8*
     +    CA**3*lntm*lnum - 4*CA**3*lntm**2 + 4*CA**3*lnum**2 )
      FSxSgg = FSxSgg + prefactor*BQED*(1-2*t1*u1/s**2)
     +  * ( 4*Lbeta*b2 - 4*Lbeta*CA**(-1) - 4*Lbeta*CA*lnsm + 
     +    8*Lbeta*CA*lnum - 2*Lbeta**2*CA**(-1) - 2*Lbeta**2*
     +    CA + 8*b2*lntm - 8*b2*lnum + 4*b2 - 2*CA**(-1)-8*CA*lnsm*
     +    lntm + 8*CA*lnsm*lnum - 4*CA*lnsm - 8*CA*lntm*lnum+8*CA*
     +    lntm + 12*CA*lntm**2 - 4*CA*lnum**2 + 2*CA )
      FSxSgg = FSxSgg + prefactor*BQED*(CA**2-1d0)**(-1)
     +  * ( 8*Lbeta*b2 - 8*Lbeta*CA*lnsm + 8*Lbeta*CA*lntm + 8
     +    *Lbeta*CA*lnum - 8*Lbeta*CA**3*s**(-2)*u1**2*lntm + 8*
     +    Lbeta*CA**3*s**(-2)*u1**2*lnum - 4*Lbeta**2*CA + 8*b2*
     +    CA**2*s**(-2)*u1**2*lntm - 8*b2*CA**2*s**(-2)*u1**2*lnum 
     +     - 16*b2*s**(-2)*u1**2*lntm + 16*b2*s**(-2)*u1**2*lnum 
     +     - 16*CA**(-1)*lntm*lnum + 8*CA**(-1)*lntm**2 
     +     + 8*CA**(-1)*lnum**2 + 32*CA*s**(-2)*u1**2*lnsm*lntm 
     +     - 32*CA*s**(-2)*u1**2*lnsm*lnum )
      FSxSgg = FSxSgg + prefactor*BQED*(CA**2-1d0)**(-1)
     +  * (  - 32*CA*s**(-2)*u1**2*lntm**2 + 32*CA*s**(-2)*u1**2*
     +    lnum**2 - 8*CA*lnsm*lntm - 8*CA*lnsm*lnum + 4*CA*lnsm**2 
     +     + 40*CA*lntm*lnum - 12*CA*lntm**2 - 12*CA*lnum**2 
     +     - 8*CA**3*s**(-2)*u1**2*lnsm*lntm 
     +     + 8*CA**3*s**(-2)*u1**2*lnsm*lnum 
     +     + 8*CA**3*s**(-2)*u1**2*lntm**2 
     +     - 8*CA**3*s**(-2)*u1**2*lnum**2
     +     - 8*CA**3*lntm*lnum + 4*CA**3*lntm**2 + 4*CA**3*lnum**2)
      FSxSgg = FSxSgg + prefactor*BQED * (  - 4*Lbeta*b2
     +    *CA**(-2) + 4*Lbeta*CA**(-3) + 4*Lbeta*CA**(-1) + 8*
     +    Lbeta*CA*s**(-2)*u1**2*lntm - 8*Lbeta*CA*s**(-2)*u1**2*
     +    lnum + 2*Lbeta**2*CA**(-3) + 6*Lbeta**2*CA**(-1) - 4*b2
     +    *CA**(-2) - 16*b2*s**(-2)*u1**2*lntm+16*b2*s**(-2)*u1**2*
     +    lnum + 2*CA**(-3) - 16*CA**(-1)*lntm*lnum + 8*CA**(-1)*
     +    lntm**2 + 8*CA**(-1)*lnum**2 - 2*CA**(-1) + 16*CA*s**(-2)*
     +    u1**2*lnsm*lntm - 16*CA*s**(-2)*u1**2*lnsm*lnum - 8*CA*
     +    s**(-2)*u1**2*lntm )
      FSxSgg = FSxSgg + prefactor*BQED * (  - 16*CA*s**(-2)
     +    *u1**2*lntm**2 + 8*CA*s**(-2)*u1**2*lnum + 16*CA*s**(-2)*
     +    u1**2*lnum**2 + 8*CA*lntm*lnum - 4*CA*lntm**2 
     +     - 4*CA*lnum**2)

      SxSgg = FSxSgg

      return
      end

C*******************************************************************


      real*8 function SxSgg2(s,t1,u1)
      implicit none

      real*8 Lbeta, lntm, lnum, lnsm
      real*8 s,t,u,m2,t1,u1,x,beta
      real*8 zeta2,b2,Kodaira,zeta3
      real*8 ca, cf, co, ck, cqed, tf, nf  
      real*8 BQED,prefactor1,sigmaBorn
      real*8 FSxSgg2,Mbeta,Nbeta,SoftG2
      real*8 betasq,b1mbe,b1pbe,s11xsq,s21xsq
      real*8 pi,xsq
      real*8 g22,g11,g23,g32,g13,g31
      real*8 g222,g211,g223,g232,g213,g231
      real*8 UG2gg,CoeBornGG,CoeColflow
      real*8 TrH0G1S0,leftover0
      real*8 dump1,dump2

      complex*16 WGPLG
      parameter(pi = 3.141592653589793238d0)
  
      common/m2only/m2
      common/group/ca, cf, co, ck, cqed, tf, nf

      zeta2 = pi*pi/6.0d0
      zeta3 = 1.2020569031595942d0
      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0

      beta = dsqrt(1d0-4*m2/s)
      betasq = beta*beta
      x = (1d0-beta)/(1d0+beta)
      xsq = x*x
      b1mbe = 1d0 - beta
      b1pbe = 1d0 + beta
      Lbeta=(1d0-2*m2/s)/beta*dlog(x)

      s21xsq=realpart(WGPLG(2,1,xsq))
      s11xsq=realpart(WGPLG(1,1,xsq))
      
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)
      prefactor1 = m2/s**2*pi/(CA**2 - 1d0)**2
      BQED = ((t1**2+u1**2)/(u1*t1)+4*m2*s/t1/u1*(1-m2*s/t1/u1))


      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      dump2=(s/4d0/m2-1d0)/((s/4d0/m2-1d0)+10d0)


      sigmaBorn = m2/s**2*pi/2./(CA**2-1d0)**2
     +  *BQED*(CO*(1d0-2d0*t1*u1/s**2)-CK)
      


      Mbeta = 0.5d0 + 0.5d0*zeta2 + 0.5d0*dlog(x)**2
     ~  - (1d0 + betasq)**2/8d0/betasq*(zeta3 
     ~  + zeta2*dlog(x) + 1d0/3d0*dlog(x)**3
     ~  + dlog(x)*s11xsq - s21xsq)
     ~  - (1d0 + betasq)/4d0/beta*(zeta2 - zeta2*dlog(x)
     ~  + dlog(x)**2 - 1d0/3d0*dlog(x)**3
     ~  + 2d0*dlog(x)*dlog(b1pbe**2/4d0/beta) - s11xsq)


      Nbeta = 0.5d0*dlog(x)**2 - (1d0 + betasq)/4d0/beta*(
     ~  dlog(x)**2 + 2d0*dlog(x)*dlog(b1pbe**2/4d0/beta) - s11xsq)


!Order alphas^1

      g11 = CF*(Lbeta+1d0)
      g31 = 2d0*(lntm-lnum)
      g23 = CA/2.*(lntm-lnum)
      g32 = (CA**2-4.)/2d0/CA*(lntm-lnum)
      g13 = (lntm-lnum)
      g22 = CF*(Lbeta+1d0) - CA/2.*(lntm+lnum-lnsm + Lbeta)

!Order alphas^2

      g211 = Kodaira/2.*g11 + CF*CA*Mbeta
      g231 = Kodaira/2.*g31 + CA*Nbeta*(lnum-lntm) 
      g213 = Kodaira/2.*g13 - CA/2.*Nbeta*(lnum-lntm)
      g222 = Kodaira/2.*g22 + CA*(CF-CA/2.)*Mbeta
      g232 = Kodaira/2.*g32
      g223 = Kodaira/2.*g23


      SoftG2 = 0d0

      SoftG2 = SoftG2 + BQED*prefactor1
     ~  *(CK*g211 - 2*CK*g222 + (CO*g222)/2. 
     ~  + (-1d0+2d0*(t1**2+u1**2)/s**2)*CO*g222/2. 
     ~  + (t1**2-u1**2)/s**2*(-2*CK*g223 + (CO*g223)/2. + (CO*g232)/2.
     ~  + (CA**2-1d0)*g213 + ((CA**2-1.d0)*g231)/2.))

      
! Universal two-loop contrib. for gg initiated processes 
      UG2gg=CA**2*(7./2.*zeta3 + 22./3.*zeta2-41./108.)
     >  + nf*CA*(-4./3.*zeta2 -5./54.)


      TrH0G1S0 = 0d0

      TrH0G1S0 = TrH0G1S0 + BQED*prefactor1*
     ~  (CF*CK - CF*CO - CA*CK*Lbeta + CF*CK*Lbeta 
     ~  + (CA*CO*Lbeta)/2. - CF*CO*Lbeta + CA*CK*lnsm - (CA*CO*lnsm)/2.
     ~  - CA*CK*lntm +(CA*CO*lntm)/2. - CA*CK*lnum + (CA*CO*lnum)/2. 
     ~  -(CA*CO*lntm*t1**2)/(2.*s**2) +(CA*CO*lnum*t1**2)/(2.*s**2) 
     ~  + (2*CF*CO*t1*u1)/s**2 - (CA*CO*Lbeta*t1*u1)/s**2 
     ~  + (2*CF*CO*Lbeta*t1*u1)/s**2 +(CA*CO*lnsm*t1*u1)/s**2 
     ~  - (CA*CO*lntm*t1*u1)/s**2 - (CA*CO*lnum*t1*u1)/s**2
     ~  + (CA*CO*lntm*u1**2)/(2.*s**2) -(CA*CO*lnum*u1**2)/(2.*s**2))






      leftover0=(-(CA*CF*CK*lnsm*lntm) + CA*CF*CO*lnsm*lntm + CA**2*CK
     >  *Lbeta*lnsm*lntm - CA*CF*CK*Lbeta*lnsm*lntm -(CA**2*CO*Lbeta
     >  *lnsm*lntm)/2. + CA*CF*CO*Lbeta*lnsm*lntm - CA**2*CK*lnsm**2
     >  *lntm + (CA**2*CO*lnsm**2*lntm)/2. +CA*CF*CK*lntm**2 - CA*CF*CO
     >  *lntm**2 - CA**2*CK*Lbeta*lntm**2 + CA*CF*CK*Lbeta*lntm**2 + (CA
     >  **2*CO*Lbeta*lntm**2)/2. -CA*CF*CO*Lbeta*lntm**2 + 2*CA**2*CK
     >  *lnsm*lntm**2 - CA**2*CO*lnsm*lntm**2 - CA**2*CK*lntm**3 + (CA
     >  **2*CO*lntm**3)/2. -CA*CF*CK*lnsm*lnum + CA*CF*CO*lnsm*lnum + CA
     >  **2*CK*Lbeta*lnsm*lnum - CA*CF*CK*Lbeta*lnsm*lnum -(CA**2*CO
     >  *Lbeta*lnsm*lnum)/2. + CA*CF*CO*Lbeta*lnsm*lnum - CA**2*CK*lnsm
     >  **2*lnum + (CA**2*CO*lnsm**2*lnum)/2. +2*CA**2*CK*lnsm*lntm*lnum
     >  - CA**2*CO*lnsm*lntm*lnum - CA**2*CK*lntm**2*lnum + (CA**2*CO
     >  *lntm**2*lnum)/2. +CA*CF*CK*lnum**2 - CA*CF*CO*lnum**2 - CA**2
     >  *CK*Lbeta*lnum**2 + CA*CF*CK*Lbeta*lnum**2 + (CA**2*CO*Lbeta
     >  *lnum**2)/2. -CA*CF*CO*Lbeta*lnum**2 + 2*CA**2*CK*lnsm*lnum**2 -
     >  CA**2*CO*lnsm*lnum**2 - CA**2*CK*lntm*lnum**2 +(CA**2*CO*lntm
     >  *lnum**2)/2. - CA**2*CK*lnum**3 + (CA**2*CO*lnum**3)/2. + (CA**2
     >  *CO*lnsm*lntm**2*t1**2)/(2.*s**2) -(CA**2*CO*lntm**3*t1**2)/(2.
     >  *s**2) + (CA**2*CO*lntm**2*lnum*t1**2)/(2.*s**2) -(CA**2*CO*lnsm
     >  *lnum**2*t1**2)/(2.*s**2) - (CA**2*CO*lntm*lnum**2*t1**2)/(2.*s
     >  **2) +(CA**2*CO*lnum**3*t1**2)/(2.*s**2) - (2*CA*CF*CO*lnsm*lntm
     >  *t1*u1)/s**2 + (CA**2*CO*Lbeta*lnsm*lntm*t1*u1)/s**2 -(2*CA*CF
     >  *CO*Lbeta*lnsm*lntm*t1*u1)/s**2 - (CA**2*CO*lnsm**2*lntm*t1*u1)
     >  /s**2 + (2*CA*CF*CO*lntm**2*t1*u1)/s**2 -(CA**2*CO*Lbeta*lntm**2
     >  *t1*u1)/s**2 + (2*CA*CF*CO*Lbeta*lntm**2*t1*u1)/s**2 + (2*CA**2
     >  *CO*lnsm*lntm**2*t1*u1)/s**2 -(CA**2*CO*lntm**3*t1*u1)/s**2 - (2
     >  *CA*CF*CO*lnsm*lnum*t1*u1)/s**2 + (CA**2*CO*Lbeta*lnsm*lnum*t1
     >  *u1)/s**2 -(2*CA*CF*CO*Lbeta*lnsm*lnum*t1*u1)/s**2 - (CA**2*CO
     >  *lnsm**2*lnum*t1*u1)/s**2 +(2*CA**2*CO*lnsm*lntm*lnum*t1*u1)/s
     >  **2 - (CA**2*CO*lntm**2*lnum*t1*u1)/s**2 + (2*CA*CF*CO*lnum**2
     >  *t1*u1)/s**2 -(CA**2*CO*Lbeta*lnum**2*t1*u1)/s**2 + (2*CA*CF*CO
     >  *Lbeta*lnum**2*t1*u1)/s**2 + (2*CA**2*CO*lnsm*lnum**2*t1*u1)/s
     >  **2 -(CA**2*CO*lntm*lnum**2*t1*u1)/s**2 - (CA**2*CO*lnum**3*t1
     >  *u1)/s**2 - (CA**2*CO*lnsm*lntm**2*u1**2)/(2.*s**2) +(CA**2*CO
     >  *lntm**3*u1**2)/(2.*s**2) - (CA**2*CO*lntm**2*lnum*u1**2)/(2.*s
     >  **2) +(CA**2*CO*lnsm*lnum**2*u1**2)/(2.*s**2) + (CA**2*CO*lntm
     >  *lnum**2*u1**2)/(2.*s**2) - (CA**2*CO*lnum**3*u1**2)/(2.*s**2))
     >  /(-1 + CA**2)**2


      CoeBornGG = SigmaBorn*(
     >  UG2gg 
     >  + zeta3*(4.*CA)**2
     >  + CA*Kodaira*(lnsm-lntm-lnum)
     >  - zeta2*8.*CA**2*(lnsm - lntm - lnum)
     >  + b2*CA*(-lnsm**2+2*lnsm*lntm-2*lntm**2+2*lnsm*lnum-2*lnum**2)
     >  + CA**2*(-2*lnsm**2*lntm + 4*lnsm*lntm**2 -2*lntm**3 -2*lnsm**2
     >  *lnum +4*lnsm*lntm*lnum -2*lntm**2*lnum + 4*lnsm*lnum**2 - 2
     >  *lntm*lnum**2 - 2*lnum**3)
     >  )



      CoeColflow = BQED*prefactor1*(CA**2-1.)**2*leftover0 
     >  - zeta2*4.*CA*(TrH0G1S0)



      FSxSgg2=0d0
      FSxSgg2 = FSxSgg2 + SoftG2 + CoeColflow + CoeBornGG


      SxSgg2=FSxSgg2*dump1

      return
      end
C*******************************************************************

      real*8 function SxSgg3del(s,t1,u1)
      implicit none

      real*8 Lbeta, lntm, lnum, lnsm
      real*8 s,t,u,m2,t1,u1,x,beta
      real*8 zeta2,b2,Kodaira,zeta3,zeta4
      real*8 ca, cf, co, ck, cqed, tf, nf  
      real*8 BQED,prefactor1,sigmaBorn
      real*8 FSxSgg3del
      real*8 betasq,b1mbe,b1pbe,s11xsq,s21xsq
      real*8 pi,xsq
      real*8 TrH0G1S0,G123X
      real*8 Acgg,T2gg1PI,Fcgg,gam11,gam22
      real*8 dump1, dump2


      complex*16 WGPLG
      parameter(pi = 3.141592653589793238d0)
  
      common/m2only/m2
      common/group/ca, cf, co, ck, cqed, tf, nf

      zeta2 = pi*pi/6.0d0
      zeta3 = 1.2020569031595942d0
      zeta4 = pi**4/90.0d0
      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0

      beta = dsqrt(1d0-4*m2/s)
      betasq = beta*beta
      x = (1d0-beta)/(1d0+beta)
      xsq = x*x
      b1mbe = 1d0 - beta
      b1pbe = 1d0 + beta
      Lbeta=(1d0-2*m2/s)/beta*dlog(x)

      s21xsq=realpart(WGPLG(2,1,xsq))
      s11xsq=realpart(WGPLG(1,1,xsq))
      
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)
      prefactor1 = m2/s**2*pi/(CA**2 - 1d0)**2
      BQED = ((t1**2+u1**2)/(u1*t1)+4*m2*s/t1/u1*(1-m2*s/t1/u1))


      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      dump2=(s/4d0/m2-1d0)/((s/4d0/m2-1d0)+10d0)



      sigmaBorn = m2/s**2*pi/2./(CA**2-1d0)**2
     ~  *BQED*(CO*(1d0-2d0*t1*u1/s**2)-CK)

      TrH0G1S0=0d0
      
      TrH0G1S0 = TrH0G1S0 + BQED*prefactor1*
     ~  (CF*CK - CF*CO - CA*CK*Lbeta + CF*CK*Lbeta 
     ~  + (CA*CO*Lbeta)/2. - CF*CO*Lbeta + CA*CK*lnsm - (CA*CO*lnsm)/2.
     ~  - CA*CK*lntm +(CA*CO*lntm)/2. - CA*CK*lnum + (CA*CO*lnum)/2. 
     ~  -(CA*CO*lntm*t1**2)/(2.*s**2) +(CA*CO*lnum*t1**2)/(2.*s**2) 
     ~  + (2*CF*CO*t1*u1)/s**2 - (CA*CO*Lbeta*t1*u1)/s**2 
     ~  + (2*CF*CO*Lbeta*t1*u1)/s**2 +(CA*CO*lnsm*t1*u1)/s**2 
     ~  - (CA*CO*lntm*t1*u1)/s**2 - (CA*CO*lnum*t1*u1)/s**2
     ~  + (CA*CO*lntm*u1**2)/(2.*s**2) -(CA*CO*lnum*u1**2)/(2.*s**2))
      



      G123X = 0d0
      G123X = G123X + BQED*prefactor1*((2*(-1 + CA**2)*CF**2)/CA - 4*(-1
     >  + CA**2)*CF*Lbeta + (4*(-1 + CA**2)*CF**2*Lbeta)/CA +CA*(-1 + CA
     >  **2)*Lbeta**2 - 4*(-1 + CA**2)*CF*Lbeta**2 + (2*(-1 + CA**2)*CF
     >  **2*Lbeta**2)/CA +CA*(-1 + CA**2)*(-lntm + lnum)**2 - 4*(-1 + CA
     >  **2)*CF*(-lnsm + lntm + lnum) +2*CA*(-1 + CA**2)*Lbeta*(-lnsm
     >  +lntm +lnum) - 4*(-1 + CA**2)*CF*Lbeta*(-lnsm + lntm + lnum) +CA
     >  *(-1 +CA**2)*(-lnsm + lntm + lnum)**2 - (2*CA*(-1 + CA**2)*CF**2
     >  *t1**2)/s**2 +(2*CA**2*(-1 + CA**2)*CF*Lbeta*t1**2)/s**2 - (4*CA
     >  *(-1 +CA**2)*CF**2*Lbeta*t1**2)/s**2 -(CA**3*(-1 + CA**2)*Lbeta
     >  **2*t1**2)/(2.*s**2) + (2*CA**2*(-1 + CA**2)*CF*Lbeta**2*t1**2)
     >  /s**2-(2*CA*(-1 + CA**2)*CF**2*Lbeta**2*t1**2)/s**2 + (2*CA**2*(
     >  -1 +CA**2)*CF*(-lntm + lnum)*t1**2)/s**2 +(2*CA*(-1 + CA**2)
     >  *Lbeta*(-lntm + lnum)*t1**2)/s**2 - (CA**3*(-1 + CA**2)*Lbeta*(
     >  -lntm +lnum)*t1**2)/s**2 +(2*CA**2*(-1 + CA**2)*CF*Lbeta*(-lntm+
     >  lnum)*t1**2)/s**2 - (2*CA*(-1 + CA**2)*(-lntm + lnum)**2*t1**2)
     >  /s**2-(CA**3*(-1 + CA**2)*(-lntm + lnum)**2*t1**2)/(2.*s**2)+(2
     >  *CA**2*(-1 + CA**2)*CF*(-lnsm + lntm + lnum)*t1**2)/s**2 -(CA**3
     >  *(-1 + CA**2)*Lbeta*(-lnsm + lntm + lnum)*t1**2)/s**2 +(2*CA**2
     >  *(-1 + CA**2)*CF*Lbeta*(-lnsm + lntm + lnum)*t1**2)/s**2 +(2*CA
     >  *(-1 + CA**2)*(-lntm + lnum)*(-lnsm + lntm + lnum)*t1**2)/s**2
     >  -(CA**3*(-1 + CA**2)*(-lntm + lnum)*(-lnsm + lntm + lnum)*t1**2)
     >  /s**2 -(CA**3*(-1 + CA**2)*(-lnsm + lntm + lnum)**2*t1**2)/(2.*s
     >  **2) - (2*CA*(-1 + CA**2)*CF**2*u1**2)/s**2 +(2*CA**2*(-1+ CA**2
     >  )*CF*Lbeta*u1**2)/s**2 - (4*CA*(-1 + CA**2)*CF**2*Lbeta*u1**2)/s
     >  **2 -(CA**3*(-1 + CA**2)*Lbeta**2*u1**2)/(2.*s**2) + (2*CA**2*(
     >  -1 + CA**2)*CF*Lbeta**2*u1**2)/s**2 -(2*CA*(-1 + CA**2)*CF**2
     >  *Lbeta**2*u1**2)/s**2 - (2*CA**2*(-1 + CA**2)*CF*(-lntm +lnum)
     >  *u1**2)/s**2 -(2*CA*(-1 + CA**2)*Lbeta*(-lntm + lnum)*u1**2)/s
     >  **2 + (CA**3*(-1 + CA**2)*Lbeta*(-lntm + lnum)*u1**2)/s**2-(2*CA
     >  **2*(-1 + CA**2)*CF*Lbeta*(-lntm + lnum)*u1**2)/s**2 - (2*CA*(-1
     >  + CA**2)*(-lntm + lnum)**2*u1**2)/s**2 -(CA**3*(-1 + CA**2)*(
     >  -lntm + lnum)**2*u1**2)/(2.*s**2) +(2*CA**2*(-1 + CA**2)*CF*(
     >  -lnsm + lntm + lnum)*u1**2)/s**2 -(CA**3*(-1 + CA**2)*Lbeta*(
     >  -lnsm + lntm + lnum)*u1**2)/s**2 +(2*CA**2*(-1 + CA**2)*CF*Lbeta
     >  *(-lnsm + lntm + lnum)*u1**2)/s**2 -(2*CA*(-1 + CA**2)*(-lntm
     >  +lnum)*(-lnsm + lntm + lnum)*u1**2)/s**2 +(CA**3*(-1 + CA**2)*(
     >  -lntm + lnum)*(-lnsm + lntm + lnum)*u1**2)/s**2 -(CA**3*(-1 + CA
     >  **2)*(-lnsm + lntm + lnum)**2*u1**2)/(2.*s**2))
      


      FSxSgg3del = 0d0
      FSxSgg3del = FSxSgg3del  
     >  + zeta2**2*sigmaBorn*4d0*CA**2
     >  - zeta4*12d0*sigmaBorn*CA**2
     >  + zeta3*sigmaBorn*8d0*CA**2*(lnsm-lntm-lnum) 
     >  - zeta3*4d0*CA*TrH0G1S0
     >  - zeta2*TrH0G1S0*(b2 + 2.*CA*lntm + 2.*CA*lnum - 2.*CA*lnsm)
     >  - zeta2*sigmaBorn*2d0*CA**2*(lnsm-lntm-lnum)**2
     >  + zeta2*G123X


      SxSgg3del = FSxSgg3del*dump1

      return
      end



C*******************************************************************

      real*8 function SxSqq(s,t1,u1)
      implicit none
      real*8 Lbeta, lntm, lnum, lnsm
      real*8 s,t,u,m2,t1,u1,x,beta
      real*8 zeta2,b2,Kodaira
      real*8 ca, cf, co, ck, cqed, tf, nf  
      real*8 BQED,prefactor
      real*8 FSxSqq
      real*8 dump1, dump2
      real*8 pi
      parameter(pi = 3.141592653589793238d0)

      common/m2only/m2
      common/group/ca, cf, co, ck, cqed, tf, nf     

      zeta2 = pi*pi/6
      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0

      beta = dsqrt(1d0-4*m2/s)
      x = (1d0-beta)/(1d0+beta)
      Lbeta=(1d0-2*m2/s)/beta*dlog(x)
      
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)
      prefactor = m2/s**2/16d0/pi**3*CF/CA
      BQED = ((t1**2+u1**2)/s**2+2*m2/s)


      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      dump2=(s/4d0/m2-1d0)/((s/4d0/m2-1d0)+10d0)

      FSxSqq = 0d0

      FSxSqq = 
     +  + CA**(-1)*CF * (  - 16*lntm*lnum + 8*lntm**2 + 8*lnum**2 )
      FSxSqq = FSxSqq + CA*CF * ( 8*Lbeta*lnsm - 36*Lbeta
     +    *lntm + 20*Lbeta*lnum - 4*Lbeta - 4*Lbeta**2 
     +    + 36*lnsm*lntm - 20*lnsm*lnum + 4*lnsm - 4*lnsm**2 
     +    + 88*lntm*lnum
     +     - 16*lntm - 80*lntm**2 + 8*lnum - 24*lnum**2 )
      FSxSqq = FSxSqq + CA * (  - 2*Lbeta*b2 + 2*b2*lnsm - 8
     +    *b2*lntm + 4*b2*lnum )
      FSxSqq = FSxSqq + CA**2 * (  - 2*Lbeta*lnsm + 8*
     +    Lbeta*lntm - 4*Lbeta*lnum + Lbeta**2 - 8*lnsm*lntm
     +     + 4*lnsm*lnum + lnsm**2 - 16*lntm*lnum + 16*lntm**2 
     +     + 4*lnum**2 )
      FSxSqq = FSxSqq + CF * ( 2*Kodaira + 4*Lbeta*b2 - 4*b2
     +    *lnsm + 20*b2*lntm - 12*b2*lnum + 4*b2 )
      FSxSqq = FSxSqq + CF**2 * ( 4 - 16*zeta2 - 8*Lbeta*lnsm
     +     + 40*Lbeta*lntm - 24*Lbeta*lnum + 8*Lbeta + 4*
     +    Lbeta**2 - 40*lnsm*lntm + 24*lnsm*lnum - 8*lnsm + 4*
     +    lnsm**2 - 120*lntm*lnum + 40*lntm + 100*lntm**2 
     +    - 24*lnum + 36*lnum**2 )

      SxSqq = prefactor*BQED*FSxSqq

      
      return
      end

C*************************************************************************
cmarco Implementation of the QQ soft anomalous dimension terms at alphas^2

      real*8 function SxSqq2(s,t1,u1)
      implicit none

      real*8 Lbeta, lntm, lnum, lnsm
      real*8 s,t,u,m2,t1,u1,x,beta
      real*8 zeta2,b2,Kodaira,zeta3
      real*8 ca, cf, co, ck, cqed, tf, nf  
      real*8 BQED,prefactor1,sigmaBorn
      real*8 FSxSqq2,Mbeta,Nbeta,SoftG2
      real*8 betasq,b1mbe,b1pbe,s11xsq,s21xsq
      real*8 pi,xsq,Coe1
      real*8 Gqq11,Gqq12,Gqq21,Gqq22
      real*8 Gqq211,Gqq212,Gqq221,Gqq222
      real*8 UGqq2,dump1,dump2

      complex*16 WGPLG
      parameter(pi = 3.141592653589793238d0)
  
      common/m2only/m2
      common/group/ca, cf, co, ck, cqed, tf, nf

      zeta2 = pi*pi/6.0d0
      zeta3 = 1.2020569031595942d0
      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0

      beta = dsqrt(1d0-4*m2/s)
      betasq = beta*beta
      x = (1d0-beta)/(1d0+beta)
      xsq = x*x
      b1mbe = 1d0 - beta
      b1pbe = 1d0 + beta
      Lbeta=(1d0-2*m2/s)/beta*dlog(x)

      s21xsq=realpart(WGPLG(2,1,xsq))
      s11xsq=realpart(WGPLG(1,1,xsq))
      
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)


      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      dump2=(s/4d0/m2-1d0)/((s/4d0/m2-1d0)+10d0)



      prefactor1 = m2/s**2*pi*CF/CA
      BQED = ((t1**2+u1**2)/s**2+2*m2/s)

      sigmaBorn = prefactor1*BQED
      


      Mbeta = 0.5d0 + 0.5d0*zeta2 + 0.5d0*dlog(x)**2
     ~  - (1d0 + betasq)**2/8d0/betasq*(zeta3 
     ~  + zeta2*dlog(x) + 1d0/3d0*dlog(x)**3
     ~  + dlog(x)*s11xsq - s21xsq)
     ~  - (1d0 + betasq)/4d0/beta*(zeta2 - zeta2*dlog(x)
     ~  + dlog(x)**2 - 1d0/3d0*dlog(x)**3
     ~  + 2d0*dlog(x)*dlog(b1pbe**2/4d0/beta) - s11xsq)


      Nbeta = 0.5d0*dlog(x)**2 - (1d0 + betasq)/4d0/beta*(
     ~  dlog(x)**2 + 2d0*dlog(x)*dlog(b1pbe**2/4d0/beta) - s11xsq)



!Order alphas^1
      Gqq11 = -CF*(Lbeta+1d0)
      Gqq12 =  CF/CA*(lnum-lntm)
      Gqq21 =  2d0*(lnum-lntm)
      Gqq22 =  CF*(4d0*(lnum-lntm) - Lbeta - 1d0)
     ~  +CA/2.*(-3d0*(lnum-lntm) +(lnum +lntm-lnsm) + Lbeta)

!Order alphas^2
      Gqq211 = Kodaira/2.*Gqq11 + CF*CA*Mbeta
      Gqq212 = Kodaira/2.*Gqq12 - CF/2.*Nbeta*(lnum-lntm) 
      Gqq221 = Kodaira/2.*Gqq21 + CA*Nbeta*(lnum-lntm)
      Gqq222 = Kodaira/2.*Gqq22 + CA*(CF-CA/2.)*Mbeta

      SoftG2 = 0d0
      SoftG2 = SoftG2 + sigmaBorn*2d0*Gqq222




      UGqq2 = CF*CA*(7./2.*zeta3 + 22./3.*zeta2 - 299./27.)
     >      + nf*CF*(-4./3.*zeta2 + 50./27.)



      Coe1 = 0d0
      Coe1 = Coe1 + sigmaBorn*(
     >  UGqq2 
     >  + zeta3*16.*CF**2 
     >  + zeta2*4.*CF*(2.*CF*(1.+Lbeta-lnsm+lntm+lnum-4.*(lnum-lntm)) 
     >                +CA*(Lbeta+lnsm-lntm-lnum +3.*(lnum-lntm)) )
     >  - b2*(CF*(lnsm**2-2*lnsm*(lntm + lnum) +2*(lntm**2 + lnum**2)))
     >  + CF*Kodaira*(lnsm-lntm-lnum)
     >  +2.*CF*Gqq22*(lnsm*lntm -lntm**2 +lnsm*lnum -lnum**2)
     >  -2.*CF**2*(lntm**3 + lntm**2*lnum + lntm*lnum**2 + lnum**3+lnsm
     >  **2*(lntm + lnum) -2*lnsm*(lntm**2 + lntm*lnum + lnum**2)) 
     >  )


      FSxSqq2 = 0d0

      FSxSqq2 = FSxSqq2 + Coe1 + SoftG2 

      
      SxSqq2 = FSxSqq2 
      
      return 
      end



C**************************************************************************************
      real*8 function SxSqq3del(s,t1,u1)
      implicit none

      real*8 Lbeta, lntm, lnum, lnsm
      real*8 s,t,u,m2,t1,u1,x,beta
      real*8 zeta2,b2,Kodaira,zeta3,zeta4
      real*8 ca, cf, co, ck, cqed, tf, nf  
      real*8 BQED,prefactor1,sigmaBorn
      real*8 FSxSqq3del
      real*8 betasq,b1mbe,b1pbe,s11xsq,s21xsq
      real*8 pi,xsq
      real*8 T21PI,dump1,dump2
      real*8 coez2,remnz2
      complex*16 WGPLG
      parameter(pi = 3.141592653589793238d0)
  
      common/m2only/m2
      common/group/ca, cf, co, ck, cqed, tf, nf


      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      dump2=(s/4d0/m2-1d0)/((s/4d0/m2-1d0)+10d0)

      zeta2 = pi*pi/6.0d0
      zeta3 = 1.2020569031595942d0
      zeta4 = pi**4/90.0d0
      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0

      beta = dsqrt(1d0-4*m2/s)
      betasq = beta*beta
      x = (1d0-beta)/(1d0+beta)
      xsq = x*x
      b1mbe = 1d0 - beta
      b1pbe = 1d0 + beta
      Lbeta=(1d0-2*m2/s)/beta*dlog(x)

      s21xsq=realpart(WGPLG(2,1,xsq))
      s11xsq=realpart(WGPLG(1,1,xsq))
      
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)
      prefactor1 = m2/s**2*pi*CF/CA
      BQED = ((t1**2+u1**2)/s**2+2*m2/s)


      sigmaBorn = prefactor1*BQED



      T21PI=2.*CF*(4.*(lnum-lntm) +(-lntm-lnum+lnsm) - Lbeta-1.)
     >        +CA*(-3.*(lnum-lntm)-(lnsm-lnum-lntm)+Lbeta)


      coez2= -2*b2*CF + 4*CF**2 + b2*CA*Lbeta - 2*b2*CF*Lbeta - 4*CA*CF
     >  *Lbeta + 8*CF**2*Lbeta + CA**2*Lbeta**2 - 4*CA*CF*Lbeta**2 +4*CF
     >  **2*Lbeta**2 - b2*CA*lnsm + 4*CA*CF*lnsm + 4*CF**2*lnsm - 2*CA
     >  **2*Lbeta*lnsm + 2*CA*CF*Lbeta*lnsm +4*CF**2*Lbeta*lnsm + CA**2
     >  *lnsm**2 + 2*CA*CF*lnsm**2 - 2*CF**2*lnsm**2 + 4*b2*CA*lntm - 8
     >  *b2*CF*lntm - 16*CA*CF*lntm +28*CF**2*lntm + 8*CA**2*Lbeta*lntm
     >  - 30*CA*CF*Lbeta*lntm + 28*CF**2*Lbeta*lntm - 8*CA**2*lnsm*lntm
     >  +6*CA*CF*lnsm*lntm + 20*CF**2*lnsm*lntm + 16*CA**2*lntm**2 + (8
     >  *CF*lntm**2)/CA - 56*CA*CF*lntm**2 + 46*CF**2*lntm**2 -2*b2*CA
     >  *lnum + 8*b2*CF*lnum + 8*CA*CF*lnum - 36*CF**2*lnum - 4*CA**2
     >  *Lbeta*lnum + 26*CA*CF*Lbeta*lnum -36*CF**2*Lbeta*lnum + 4*CA**2
     >  *lnsm*lnum - 14*CA*CF*lnsm*lnum - 12*CF**2*lnsm*lnum - 16*CA**2
     >  *lntm*lnum -(16*CF*lntm*lnum)/CA + 100*CA*CF*lntm*lnum - 132*CF
     >  **2*lntm*lnum + 4*CA**2*lnum**2 + (8*CF*lnum**2)/CA -36*CA*CF
     >  *lnum**2 + 78*CF**2*lnum**2

      remnz2 = coez2 + (4.*CF/CA*(lnum-lntm)**2 + 0.5*T21PI**2)


      FSxSqq3del=0.0d0
      FSxSqq3del = FSxSqq3del + sigmaBorn*( 
     >  + zeta2**2*4.*CF**2
     >  + zeta3*4d0*CF*T21PI
     >  - zeta4*12d0*CF**2
     >  + zeta2*(-4.*CF/CA*(lnum-lntm)**2 -0.5*T21PI**2) 
     >  + zeta2*remnz2
     >  )

      SxSqq3del=FSxSqq3del

      return
      end









C*******************************************************************
      real*8 function S21gg(s,t1,u1)
      implicit none

      real*8 Lbeta, lntm, lnum, lnsm
      real*8 s,t,u,m2,t1,u1,x,beta
      real*8 zeta2,b2,Kodaira
      real*8 ca, cf, co, ck, cqed, tf, nf  
      real*8 BQED,prefactor,sigmaBorn
      real*8 FS21gg
      real*8 pi
      real*8 dump1, dump2 

      parameter(pi = 3.141592653589793238d0)
  
      common/m2only/m2
      common/group/ca, cf, co, ck, cqed, tf, nf


      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      dump2=(s/4d0/m2-1d0)/((s/4d0/m2-1d0)+10d0)

      zeta2 = pi*pi/6
      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0

      beta = dsqrt(1d0-4*m2/s)
      x = (1d0-beta)/(1d0+beta)
      Lbeta=(1d0-2*m2/s)/beta*dlog(x)
      
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)

      prefactor = m2/s**2/2d0/(CA**2-1d0)**2/pi**3/16d0

      BQED = ((t1**2+u1**2)/(u1*t1)+4*m2*s/t1/u1*(1-m2*s/t1/u1))

      sigmaBorn = m2/s**2/2d0/(CA**2-1d0)**2/pi**3/16d0
     +     *BQED*(CO*(1-2*t1*u1/s**2)-CK)

      FS21gg = 0d0


      FS21gg = FS21gg 
     +      + sigmaBorn * (  - Kodaira*CA + 8d0*CA**2*zeta2
     +      +4d0*CA*b2*(lntm+lnum) -2d0*CA**2*(lntm+lnum)**2)


      FS21gg = FS21gg
     +  + prefactor*(CA**2-1d0)*(1-2*t1*u1/s**2)*BQED*( 
     +  - 2d0*b2 + 2d0*b2*CA**2 - 2d0*b2*Lbeta - 2d0*b2*CA**2*lnsm 
     +  + CA*lntm - 2d0*b2*CA**2*lntm - CA**3*lntm 
     +  + CA*Lbeta*lntm + CA**3*lnsm*lntm + CA**3*lntm**2  
     +  + CA*lnum - 2d0*b2*CA**2*lnum - CA**3*lnum 
     +  + CA*Lbeta*lnum + CA**3*lnsm*lnum 
     +  + 2*CA**3*lntm*lnum + CA**3*lnum**2)


      FS21gg = FS21gg
     +  + (t1**2-u1**2)/s**2*prefactor*(CA**2-1d0)*BQED*(
     +    2d0*b2*CA**2*lntm - CA**3*lntm**2 
     +  - 2d0*b2*CA**2*lnum + CA**3*lnum**2)


      FS21gg = FS21gg
     +  + prefactor*(CA**2-1d0)*BQED * (
     +  - 2.*b2 + (2.*b2)/CA**2 + 2.*b2*Lbeta + (2.*b2*Lbeta)/CA**2 
     +  + 4.*b2*lntm
     +  - lntm/CA + CA*lntm - (Lbeta*lntm)/CA - CA*Lbeta*lntm 
     +  - 2.*CA *lntm**2  
     +  + 4.*b2*lnum - lnum/CA + CA*lnum - (Lbeta*lnum)/CA-CA*Lbeta*lnum
     +  - 4.*CA*lntm*lnum - 2.*CA*lnum**2)
    
      S21gg=FS21gg
      

      return
      end

C******************************************************************
      real*8 function S21ggmuR(s,t1,u1)
      implicit none

      real*8 Lbeta, lntm, lnum, lnsm
      real*8 s,t,u,m2,t1,u1,x,beta
      real*8 zeta2,b2,Kodaira
      real*8 ca, cf, co, ck, cqed, tf, nf  
      real*8 BQED,prefactor,sigmaBorn
      real*8 FS21ggmuR
      real*8 pi
      real*8 dump1, dump2 

      parameter(pi = 3.141592653589793238d0)
      common/m2only/m2
      common/group/ca, cf, co, ck, cqed, tf, nf

      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      dump2=(s/4d0/m2-1d0)/((s/4d0/m2-1d0)+10d0)

      zeta2 = pi*pi/6
      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0

      beta = dsqrt(1d0-4*m2/s)
      x = (1d0-beta)/(1d0+beta)
      Lbeta=(1d0-2*m2/s)/beta*dlog(x)
      
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)
      prefactor = m2/s**2/2d0/(CA**2-1d0)**2/pi**3/16d0
      BQED = ((t1**2+u1**2)/(u1*t1)+4*m2*s/t1/u1*(1-m2*s/t1/u1))
      sigmaBorn = m2/s**2/2d0/(CA**2-1d0)**2/pi**3/16d0
     +     *BQED*(CO*(1-2*t1*u1/s**2)-CK)

      FS21ggmuR = 0d0

      FS21ggmuR = FS21ggmuR 
     +  + sigmaBorn*(-6d0*CA*b2*(lntm+lnum))                     

      FS21ggmuR = FS21ggmuR
     +  + prefactor*(CA**2-1d0)*(1-2*t1*u1/s**2)*BQED*(          
     +  3d0*b2 - 3d0*b2*CA**2 + 3d0*b2*Lbeta + 3d0*b2*CA**2*lnsm 
     +  + 3d0*b2*CA**2*lntm + 3d0*b2*CA**2*lnum)                 

      FS21ggmuR = FS21ggmuR
     +  + prefactor*(CA**2-1d0)*(t1**2-u1**2)/s**2*BQED*(        
     +  - 3d0*b2*CA**2*lntm + 3d0*b2*CA**2*lnum)                 

      FS21ggmuR = FS21ggmuR
     +  + prefactor*(CA**2-1d0)*BQED*(                           
     +   3d0*b2 - (3d0*b2)/CA**2 - 3d0*b2*Lbeta 
     + - (3d0*b2*Lbeta)/CA**2 - 6d0*b2*lntm - 6d0*b2*lnum)

      S21ggmuR = FS21ggmuR 



      return
      end



C*******************************************************************
      real*8 function S21qq(s,t1,u1)
      implicit none
      real*8 Lbeta, lntm, lnum, lnsm
      real*8 s,t,u,m2,t1,u1,x,beta
      real*8 zeta2,b2,Kodaira
      real*8 ca, cf, co, ck, cqed, tf, nf  
      real*8 BQED,prefactor
      real*8 FS21qq
      real*8 dump1, dump2

      real*8 pi
      parameter(pi = 3.141592653589793238d0)

      common/m2only/m2
      common/group/ca, cf, co, ck, cqed, tf, nf     

      zeta2 = pi*pi/6
      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0

      beta = dsqrt(1d0-4*m2/s)
      x = (1d0-beta)/(1d0+beta)
      Lbeta=(1d0-2*m2/s)/beta*dlog(x)
      
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)
      prefactor = m2/s**2/16d0/pi**3*CF/CA
      BQED = ((t1**2+u1**2)/s**2+2*m2/s)

      dump1=1.0d0/sqrt((s/4d0/m2 -1d0) +1d0)
      dump2=(s/4d0/m2-1d0)/((s/4d0/m2-1d0)+10d0)

      FS21qq = 0d0

      FS21qq =  FS21qq + prefactor*BQED*(
     ~  3d0*CF**2 - CF*Kodaira - (3d0*CA*CF*Lbeta)/2d0 + 3d0*CF**2*Lbeta 
     ~  + (3d0*CA*CF*lnsm)/2d0 - 3d0*CF**2*lnsm + 3d0*CA*CF*lntm 
     ~  + 13d0*CF**2*lntm + CA*CF*Lbeta*lntm - 2d0*CF**2*Lbeta*lntm 
     ~  - CA*CF*lnsm*lntm + 2d0*CF**2*lnsm*lntm - 2d0*CA*CF*lntm**2 
     ~  - 10d0*CF**2*lntm**2 - 6d0*CA*CF*lnum - 11d0*CF**2*lnum 
     ~  + CA*CF*Lbeta*lnum - 2d0*CF**2*Lbeta*lnum - CA*CF*lnsm*lnum 
     ~  + 2d0*CF**2*lnsm*lnum + 2d0*CA*CF*lntm*lnum-4d0*CF**2*lntm*lnum 
     ~  + 4d0*CA*CF*lnum**2 + 6d0*CF**2*lnum**2 + 8d0*CF**2*zeta2 )
      
      S21qq = FS21qq
      
      return
      end


C*******************************************************************
      real*8 function S21qqmuR(s,t1,u1)
      implicit none
      real*8 Lbeta, lntm, lnum, lnsm
      real*8 s,t,u,m2,t1,u1,x,beta
      real*8 zeta2,b2,Kodaira
      real*8 ca, cf, co, ck, cqed, tf, nf  
      real*8 BQED,prefactor
      real*8 FS21qqmuR
      real*8 dump1, dump2
      real*8 lntum4, lntu, gqq22

      real*8 pi
      parameter(pi = 3.141592653589793238d0)

      common/m2only/m2
      common/group/ca, cf, co, ck, cqed, tf, nf     

      zeta2 = pi*pi/6
      Kodaira = CA*(67d0/18d0-zeta2)-5d0/9d0*nf
      b2 = (11d0*CA-2d0*nf)/12d0

      beta = dsqrt(1d0-4*m2/s)
      x = (1d0-beta)/(1d0+beta)
      Lbeta=(1d0-2*m2/s)/beta*dlog(x)
      
      lntm = dlog(-t1/m2)
      lnum = dlog(-u1/m2)
      lnsm = dlog(s/m2)
      prefactor = m2/s**2/16d0/pi**3*CF/CA
      BQED = ((t1**2+u1**2)/s**2+2*m2/s)


      FS21qqmuR = 0d0

      FS21qqmuR = FS21qqmuR + prefactor*BQED*(
     ~ - 6d0*b2*CF + 3d0*b2*CA*Lbeta - 6d0*b2*CF*Lbeta - 3d0*b2*CA*lnsm 
     ~ + 6d0*b2*CF*lnsm - 6d0*b2*CA*lntm - 30d0*b2*CF*lntm  
     ~ + 12d0*b2*CA*lnum + 18d0*b2*CF*lnum )

      S21qqmuR = FS21qqmuR

      return
      end
C*******************************************************************
